from __future__ import absolute_import

from celery import shared_task
from ldapentities.models import (
    LdapGroup,
    LdapUser,
)


@shared_task
def create_ldap_group(group):
    ldapgroup = LdapGroup(gid=group.gid, name=group.groupname)
    ldapgroup.save()
    return ldapgroup.dn


@shared_task
def create_ldap_user(user, password):
    ldapuser = LdapUser(
        uid=user.uid, group=user.group.gid, gecos=user.gecos,
        home_directory=user.homedir, login_shell=user.shell,
        username=user.username, common_name=user.username)
    ldapuser.set_password(password)
    ldapgroup = LdapGroup.objects.get(gid=ldapuser.group)
    ldapgroup.members.append(ldapuser.username)
    ldapgroup.save()
    ldapuser.save()
    return ldapuser.dn
